<form class="jira-integration-form" name="jiraIntegrationForm">
    <div class="jira-integration-form__header">
        <div class="jira-integration-form__header-content">
            <div class="jira-integration-form__integration-type">
                <md-radio-group class="jira-integration-form__integration-type-select"
                    name="integrationType"
                    ng-model="$ctrl.jiraIntegration.type"
                    ng-change="$ctrl.onIntegrationTypeChange(jiraIntegrationForm)"
                    md-no-ink>
                    <md-radio-button class="jira-integration-form__integration-type-option"
                        ng-repeat="type in $ctrl.integrationTypes"
                        ng-value="type.value"
                        md-no-ink
                        aria-label="{{type.label}}">
                        {{type.label}}
                    </md-radio-button>
                </md-radio-group>
            </div>
            <div class="jira-integration-form__integration-actions">
                <md-button name="enableIntegration"
                    title="{{ $ctrl.jiraIntegration.enabled ? 'Disable' : 'Enable' }} integration"
                    aria-label="Enable/disable integration"
                    class="md-icon-button zf-icon-button"
                    ng-class="{ _enabled: $ctrl.jiraIntegration.enabled }"
                    ng-disabled="!$ctrl.jiraIntegrationSource || $ctrl.isSaving"
                    ng-click="$ctrl.onUpdateIntegration(jiraIntegrationForm)">
                    <md-icon>power_settings_new</md-icon>
                </md-button>
            </div>
        </div>
        <div class="jira-integration-form__header-warning" ng-show="$ctrl.isWarningVisible">
            Note: switching type will result into unsaved form data being lost.
            <md-button id="closeWarningMessage"
                class="md-icon-button jira-integration-form__warning-close"
                ng-click="$ctrl.closeWarningMessage()">
                <md-icon aria-label="Close warning message">close</md-icon>
            </md-button>
        </div>
    </div>
    <div class="jira-integration-form__body">
        <md-input-container class="text-input">
            <label name="jiraIntegrationHostLabel" for="jiraIntegrationHost">Host</label>
            <input id="jiraIntegrationHost"
                name="jiraIntegrationHost"
                autocomplete="url"
                type="url"
                ng-minlength="::$ctrl.getValidationValue('url', 'minlength')"
                ng-maxlength="::$ctrl.getValidationValue('url', 'maxlength')"
                ng-pattern="::$ctrl.getValidationValue('url', 'pattern')"
                ng-trim="false"
                ng-disabled="$ctrl.isSaving"
                required
                ng-model-options="{ debounce: 500 }"
                ng-model="$ctrl.jiraIntegration.url"/>
            <div ng-messages="jiraIntegrationForm.jiraIntegrationHost.$error"
                ng-if="jiraIntegrationForm.jiraIntegrationHost.$dirty || jiraIntegrationForm.jiraIntegrationHost.$touched">
                <div ng-message="url">Entered host should be a valid URL</div>
                <div ng-repeat="validation in $ctrl.validations.url"
                    ng-message-exp="validation.name">
                    <span>
                        <md-tooltip ng-if="!$ctrl.isTouchDevice && validation.additional"
                            md-autohide
                            md-delay="300"
                            md-direction="top">{{ validation.additional }}</md-tooltip>
                        {{ validation.message }}
                    </span>
                </div>
            </div>
        </md-input-container>
        <md-input-container>
            <label name="jiraIntegrationUsernameLabel" for="jiraIntegrationUsername">Username</label>
            <input id="jiraIntegrationUsername"
                name="jiraIntegrationUsername"
                type="text"
                autocomplete="username"
                ng-minlength="::$ctrl.getValidationValue('textField', 'minlength')"
                ng-maxlength="::$ctrl.getValidationValue('textField', 'maxlength')"
                ng-pattern="::$ctrl.getValidationValue('textField', 'pattern')"
                ng-trim="false"
                ng-disabled="$ctrl.isSaving"
                required
                ng-model-options="{ debounce: 500 }"
                ng-model="$ctrl.jiraIntegration.username"/>
            <div ng-messages="jiraIntegrationForm.jiraIntegrationUsername.$error"
                ng-if="jiraIntegrationForm.jiraIntegrationUsername.$dirty || jiraIntegrationForm.jiraIntegrationUsername.$touched">
                <div ng-repeat="validation in $ctrl.validations.textField"
                    ng-message-exp="validation.name">
                    <span>
                        <md-tooltip ng-if="!$ctrl.isTouchDevice && validation.additional"
                            md-autohide
                            md-delay="300"
                            md-direction="top">{{ validation.additional }}</md-tooltip>
                        {{ validation.message }}
                    </span>
                </div>
            </div>
        </md-input-container>
        <md-input-container>
            <label name="jiraIntegrationTokenLabel" for="jiraIntegrationToken">Token</label>
            <input id="jiraIntegrationToken"
                name="jiraIntegrationToken"
                type="password"
                autocomplete="current-password"
                ng-minlength="::$ctrl.getValidationValue('textField', 'minlength')"
                ng-maxlength="::$ctrl.getValidationValue('textField', 'maxlength')"
                ng-pattern="::$ctrl.getValidationValue('textField', 'pattern')"
                ng-disabled="$ctrl.isSaving"
                ng-change="$ctrl.onTokenChange(jiraIntegrationForm.jiraIntegrationToken)"
                required
                ng-model-options="{ debounce: 500 }"
                ng-model="$ctrl.jiraIntegration.token"/>
            <div ng-messages="jiraIntegrationForm.jiraIntegrationToken.$error"
                ng-if="jiraIntegrationForm.jiraIntegrationToken.$dirty || jiraIntegrationForm.jiraIntegrationToken.$touched">
                <div ng-repeat="validation in $ctrl.validations.textField"
                    ng-message-exp="validation.name">
                    <span>
                        <md-tooltip ng-if="!$ctrl.isTouchDevice && validation.additional"
                            md-autohide
                            md-delay="300"
                            md-direction="top">{{ validation.additional }}</md-tooltip>
                        {{ validation.message }}
                    </span>
                </div>
            </div>
        </md-input-container>
    </div>
    <div class="jira-integration-form__footer">
        <div class="jira-integration-form__footer-actions">
            <md-button class="md-raised btn-w-xs _left-icon _test-integration"
                ng-click="$ctrl.onTestIntegrationConnection(jiraIntegrationForm)"
                ng-disabled="jiraIntegrationForm.$invalid || $ctrl.isSaving">
                <md-icon class="material-icons">power_outline</md-icon>
                <span class="md-button__text">Test</span>
            </md-button>
            <md-button class="md-raised btn-w-xs"
                ng-click="$ctrl.onCancelFormChanges(jiraIntegrationForm)"
                ng-disabled="jiraIntegrationForm.$pristine || $ctrl.isSaving">Cancel</md-button>
            <md-button class="md-raised btn-w-xs md-primary"
                ng-click="$ctrl.onSaveIntegration(jiraIntegrationForm)"
                ng-disabled="jiraIntegrationForm.$pristine || jiraIntegrationForm.$invalid || $ctrl.isSaving">Save</md-button>
        </div>
        <div class="jira-integration-form__footer-messages">
            <!--TODO: [-] refactor messages-->
            <div class="jira-integration-form__footer-message _connecting no-animate"
                ng-if="$ctrl.testingStatus === 'loading'">
                <md-progress-circular class="jira-integration-form__footer-message-icon"
                    md-mode="indeterminate"
                    md-diameter="16"></md-progress-circular>
                <div class="jira-integration-form__footer-message-text">Connection</div>
            </div>
            <div class="jira-integration-form__footer-message _connected no-animate"
                ng-if="$ctrl.testingStatus === 'success'">
                <md-icon class="jira-integration-form__footer-message-icon material-icons">done</md-icon>
                <div class="jira-integration-form__footer-message-text">Integration is connected.</div>
            </div>
            <div class="jira-integration-form__footer-message _failed no-animate"
                ng-if="$ctrl.testingStatus === 'fail'">
                <md-icon class="jira-integration-form__footer-message-icon material-icons">warning_amber</md-icon>
                <div class="jira-integration-form__footer-message-text">
                    <div>Connection failed.</div>
                    <div ng-repeat="messageLine in $ctrl.testingStatusMessages">{{messageLine}}</div>
                </div>
            </div>
            <div class="jira-integration-form__footer-message _failed no-animate"
                ng-if="$ctrl.testingStatus === 'error'">
                <md-icon class="jira-integration-form__footer-message-icon material-icons">warning_amber</md-icon>
                <div class="jira-integration-form__footer-message-text">
                    <div>Unable to check connection.</div>
                    <div ng-repeat="messageLine in $ctrl.testingStatusMessages">{{messageLine}}</div>
                </div>
            </div>
        </div>
    </div>
</form>
